package TiVo::Slice::Field::Enum;

use strict;
use base qw(TiVo::Slice::Field);

our $VERSION =
    (split / /, q$Id: Enum.pm,v 1.2 2002/04/20 01:07:48 grant Exp $)[2];
                                
sub new {
    my $class = shift;
    my $value = shift;

    my $match = $class->match($value);
    die "failed to match $value" unless $match; # FIXME extreme
    my $number = TiVo::Slice::Number->new($match);
    my $self = $class->SUPER::new($number->tivonumber);
    return $self;
}

sub match {
    my $class = shift;
    my $value = shift;
    
    my @enum_list = $class->enum_values;
    my @enum = map qr/^(?:$_)$/i, @enum_list;
    for (my $i = 0; $i < @enum; $i++) {
        return $i + 1 if $value =~ $enum[$i];
    }
    return;
}

sub METHOD::ABSTRACT {
    my $self = shift;
    my $object_class = ref($self);
    my ($file, $line, $method) = (caller(1))[1..3];
    my $loc = "at $file, line $line\n";
    die "someone used an (abstract) TiVo::Slice::Field::Enum object $loc"
        if $object_class eq 'TiVo::Slice::Field::Enum';
    die "call to abstract method ${method} $loc";
}

sub enum_values { ABSTRACT METHOD @_ }

1;
